/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern1 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern14 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern21 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x4, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x3, 1);
  if (GET_CODE (x7) != LABEL_REF)
    return -1;
  x8 = XEXP (x3, 2);
  if (GET_CODE (x8) != PC)
    return -1;
  x9 = XEXP (x2, 0);
  if (GET_CODE (x9) != PC)
    return -1;
  x10 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x10) != SET)
    return -1;
  x11 = XEXP (x10, 1);
  if (GET_CODE (x11) != PLUS
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 2
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != MINUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != PC)
    return -1;
  x7 = XEXP (x5, 1);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x8 = XEXP (x1, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 25
      || GET_MODE (x8) != E_SImode)
    return -1;
  return 0;
}

int
pattern51 (rtx x1, unsigned int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != i1
      || GET_MODE (x5) != E_SImode
      || !register_operand (operands[0], E_SImode)
      || !tgd_symbolic_operand (operands[1], E_VOIDmode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != E_SImode)
    return -1;
  return 0;
}

int
pattern61 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i2)
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_MODE (x5) != i2)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != i1)
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) == REG
          && REGNO (x3) == 0
          && GET_MODE (x3) == E_CCFPmode)
        {
          switch (XWINT (x2, 0))
            {
            case 0L:
              if (
#line 750 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return 3; /* *movccfp0 */
              break;

            case 1L:
              if (
#line 758 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT))
                return 4; /* *movccfp1 */
              break;

            default:
              break;
            }
        }
      break;

    case REG:
    case SUBREG:
      operands[0] = x2;
      if (pmode_register_operand (operands[0], E_VOIDmode))
        {
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) == PC)
            return 200; /* indirect_jump */
        }
      break;

    default:
      break;
    }
  operands[3] = x2;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != ZERO_EXTRACT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  if (!uint5_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  if (!uint5_operand (operands[2], E_SImode))
    return -1;
  if (arith5_operand (operands[3], E_SImode)
      && 
#line 9429 "../../gcc/config/pa/pa.md"
(UINTVAL (operands[1]) > 0
   && UINTVAL (operands[1]) + UINTVAL (operands[2]) <= 32))
    return 230; /* insv_32 */
  if (!const_int_operand (operands[3], E_SImode)
      || !
#line 9443 "../../gcc/config/pa/pa.md"
((INTVAL (operands[3]) & 0x10) != 0 &&
   (~INTVAL (operands[3]) & ((1L << INTVAL (operands[1])) - 1) & ~0xf) == 0))
    return -1;
  return 231; /* *pa.md:9438 */
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
      if (ordered_comparison_operator (x3, E_VOIDmode))
        {
          res = recog_1 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      x4 = XEXP (x3, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x5 = XEXP (x1, 0);
      if (GET_CODE (x5) != PC)
        return -1;
      switch (GET_CODE (x3))
        {
        case NE:
          x6 = XEXP (x3, 0);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              switch (pattern30 (x2))
                {
                case 0:
                  return 32; /* *pa.md:1591 */

                case 1:
                  return 33; /* *pa.md:1647 */

                case 2:
                  return 36; /* *pa.md:1816 */

                case 3:
                  return 37; /* *pa.md:1872 */

                default:
                  return -1;
                }

            case REG:
              if (REGNO (x6) != 0
                  || GET_MODE (x6) != E_CCFPmode)
                return -1;
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) != PC)
                    return -1;
                  x9 = XEXP (x7, 0);
                  operands[0] = x9;
                  if (!
#line 2049 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
                    return -1;
                  return 40; /* *pa.md:2045 */

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) != LABEL_REF)
                    return -1;
                  x10 = XEXP (x8, 0);
                  operands[0] = x10;
                  if (!
#line 2093 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT))
                    return -1;
                  return 41; /* *pa.md:2089 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case EQ:
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != ZERO_EXTRACT)
            return -1;
          switch (pattern30 (x2))
            {
            case 0:
              return 34; /* *pa.md:1703 */

            case 1:
              return 35; /* *pa.md:1759 */

            case 2:
              return 38; /* *pa.md:1928 */

            case 3:
              return 39; /* *pa.md:1984 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != PARALLEL)
    return NULL;
  switch (XVECLEN (x1, 0))
    {
    case 2:
      x2 = XVECEXP (x1, 0, 0);
      if (GET_CODE (x2) != SET)
        return NULL;
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
          operands[1] = x3;
          if (!symbolic_operand (operands[1], E_SImode))
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!register_operand (operands[2], E_SImode)
              || !
#line 2865 "../../gcc/config/pa/pa.md"
(! (flag_pic && pic_label_operand (operands[1], SImode))))
            return NULL;
          return gen_split_1 (insn, operands);

        case REG:
        case SUBREG:
          operands[4] = x3;
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != MEM)
            return NULL;
          x7 = XEXP (x5, 0);
          if (GET_CODE (x7) != PLUS
              || GET_MODE (x7) != E_SImode)
            return NULL;
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) != MULT
              || GET_MODE (x8) != E_SImode)
            return NULL;
          x9 = XEXP (x7, 1);
          if (GET_CODE (x9) != PLUS
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x10 = XEXP (x8, 0);
          operands[0] = x10;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x11 = XEXP (x8, 1);
          operands[1] = x11;
          if (!mem_shadd_operand (operands[1], E_SImode))
            return NULL;
          x12 = XEXP (x9, 0);
          operands[2] = x12;
          if (!register_operand (operands[2], E_SImode))
            return NULL;
          x13 = XEXP (x9, 1);
          operands[3] = x13;
          if (!const_int_operand (operands[3], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[5] = x6;
          if (!register_operand (operands[5], E_SImode))
            return NULL;
          switch (GET_MODE (x5))
            {
            case E_SImode:
              if (!register_operand (operands[4], E_SImode))
                return NULL;
              return gen_split_2 (insn, operands);

            case E_HImode:
              if (!register_operand (operands[4], E_HImode))
                return NULL;
              return gen_split_3 (insn, operands);

            case E_QImode:
              if (!register_operand (operands[4], E_QImode))
                return NULL;
              return gen_split_4 (insn, operands);

            default:
              return NULL;
            }

        case PLUS:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x14 = XEXP (x3, 0);
          operands[1] = x14;
          if (!register_operand (operands[1], E_SImode))
            return NULL;
          x15 = XEXP (x3, 1);
          operands[2] = x15;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (!register_operand (operands[4], E_SImode))
            return NULL;
          if (
#line 5244 "../../gcc/config/pa/pa.md"
(! pa_cint_ok_for_move (UINTVAL (operands[2]))
   && VAL_14_BITS_P (INTVAL (operands[2]) >> 1)))
            return gen_split_7 (insn, operands);
          if (!
#line 5263 "../../gcc/config/pa/pa.md"
(! pa_cint_ok_for_move (UINTVAL (operands[2]))))
            return NULL;
          return gen_split_8 (insn, operands);

        case NEG:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          x14 = XEXP (x3, 0);
          switch (GET_CODE (x14))
            {
            case ABS:
              switch (pattern33 (x1))
                {
                case 0:
                  if (!
#line 6449 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                    return NULL;
                  return gen_split_9 (insn, operands);

                case 1:
                  if (!
#line 6468 "../../gcc/config/pa/pa.md"
(! TARGET_SOFT_FLOAT && TARGET_PA_20))
                    return NULL;
                  return gen_split_10 (insn, operands);

                default:
                  return NULL;
                }

            case MULT:
              switch (pattern35 (x1))
                {
                case 0:
                  if (!
#line 6512 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20 && !flag_signed_zeros))
                    return NULL;
                  return gen_split_11 (insn, operands);

                case 1:
                  if (!
#line 6536 "../../gcc/config/pa/pa.md"
(!TARGET_SOFT_FLOAT && TARGET_PA_20&& !flag_signed_zeros))
                    return NULL;
                  return gen_split_12 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case 8:
      if (pattern4 (x1) != 0
          || !
#line 3358 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed && !flag_peephole2
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)
   && GET_CODE (operands[1]) == MEM
   && register_operand (XEXP (operands[1], 0), SImode)))
        return NULL;
      return gen_split_5 (insn, operands);

    case 5:
      x16 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x16) != CLOBBER)
        return NULL;
      x17 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x17) != USE)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      switch (GET_CODE (x2))
        {
        case SET:
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x18 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x18) != USE
              || pattern41 (x1) != 0
              || !
#line 3688 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed && !flag_peephole2
   && GET_CODE (operands[0]) == MEM
   && register_operand (XEXP (operands[0], 0), SImode)))
            return NULL;
          return gen_split_6 (insn, operands);

        case CALL:
          x5 = XEXP (x2, 0);
          if (GET_CODE (x5) != MEM
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != SET)
            return NULL;
          x19 = XEXP (x4, 1);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != E_SImode)
            return NULL;
          x20 = XEXP (x19, 0);
          if (GET_CODE (x20) != REG
              || REGNO (x20) != 2
              || GET_MODE (x20) != E_SImode)
            return NULL;
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != MINUS
              || GET_MODE (x21) != E_SImode)
            return NULL;
          x22 = XEXP (x21, 1);
          if (GET_CODE (x22) != PLUS
              || GET_MODE (x22) != E_SImode)
            return NULL;
          x23 = XEXP (x22, 0);
          if (GET_CODE (x23) != PC)
            return NULL;
          x24 = XEXP (x22, 1);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
            return NULL;
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) != REG
              || REGNO (x6) != 25
              || GET_MODE (x6) != E_SImode)
            return NULL;
          x25 = XEXP (x16, 0);
          if (GET_CODE (x25) != REG
              || REGNO (x25) != 2
              || GET_MODE (x25) != E_SImode
              || pattern66 (x1) != 0)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[0] = x7;
          if (!call_operand_address (operands[0], E_VOIDmode))
            return NULL;
          x3 = XEXP (x2, 1);
          operands[1] = x3;
          x26 = XEXP (x21, 0);
          operands[2] = x26;
          x18 = XVECEXP (x1, 0, 3);
          x27 = XEXP (x18, 0);
          operands[3] = x27;
          if (!
#line 8815 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case 6:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER
          || pattern10 (x1, 
1, 
2, 
CLOBBER) != 0)
        return NULL;
      x18 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x18) != CLOBBER)
        return NULL;
      x17 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x17) != USE
          || pattern46 (x1) != 0)
        return NULL;
      x2 = XVECEXP (x1, 0, 0);
      switch (pattern8 (x2))
        {
        case 0:
          switch (pattern63 (x1))
            {
            case 0:
              if (
#line 7719 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_13 (insn, operands);
              if (!
#line 7738 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_14 (insn, operands);

            case 1:
              if (
#line 7896 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_15 (insn, operands);
              if (!
#line 7915 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_16 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          switch (pattern65 (x1))
            {
            case 0:
              if (
#line 8229 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_17 (insn, operands);
              if (!
#line 8250 "../../gcc/config/pa/pa.md"
(!TARGET_PORTABLE_RUNTIME && !TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_18 (insn, operands);

            case 1:
              if (
#line 8602 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed
   && find_reg_note (insn, REG_NORETURN, NULL_RTX)))
                return gen_split_19 (insn, operands);
              if (!
#line 8623 "../../gcc/config/pa/pa.md"
(!TARGET_64BIT && reload_completed))
                return NULL;
              return gen_split_20 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
